#ifndef _GRAPHIK_H_
#define _GRAPHIK_H_

void PlotResults1D(double* xData, double* yData, int dataSize) 
// 1D Funktion als Gnuplot: Option: GraphikAusgabe in .png File
// Funktion ist punktweise gegeben
{  
  const char * commandsForGnuplot[] = {
           "set title \"Werte\" ",
           "set terminal png",
           "set output \"plot1d.png\" ",
	   "plot 'data.temp' with linespoints",
           "replot"};
  FILE * temp = fopen("data.temp", "w");
  FILE * gnuplotPipe = popen ("gnuplot -persist", "w");
  char output;
  int i,k;
    output='n';
    cout <<"Ausgabe in Datei"<<endl;
    cin >>output;
    k=1;
    if (output=='n')
      {
	k=3;
      }
    for (i=0; i < dataSize; i++)
    {
    fprintf(temp, "%f %.15f \n", xData[i], yData[i]); 
    }
    for (i=0; (i*k) < 4; i++)
    {
    fprintf(gnuplotPipe, "%s \n", commandsForGnuplot[k*i]); 
    }
}

void PlotResults1DLog(double* xData, double* yData, int dataSize) 
// 1D Funktion als Gnuplot: Option: GraphikAusgabe in .png File
// Funktion ist punktweise gegeben
{  
  const char * commandsForGnuplot[] = {
           "set title \"Werte\" ",
           "set terminal png",
           "set logscale y",
           "set output \"plot1d.png\" ",
	   "plot 'data.temp' with points",
           "replot"};
  FILE * temp = fopen("data.temp", "w");
  FILE * gnuplotPipe = popen ("gnuplot -persist", "w");
  char output;
  int i,k;
    output='n';
    cout <<"Ausgabe in Datei"<<endl;
    cin >>output;
    k=1;
    if (output=='n')
      {
	k=2;
      }
    for (i=0; i < dataSize; i++)
    {
    fprintf(temp, "%f %.15f \n", xData[i], yData[i]); 
    }
    for (i=0; (i*k) < 5; i++)
    {
    fprintf(gnuplotPipe, "%s \n", commandsForGnuplot[k*i]); 
    }
}




void PlotResults2D(double* xData, double* yData, double* zData, int dataSize) 
// 2D-Funktion in Gnuplot zeichnen
{  
  const char * commandsForGnuplot[] = 
              {"set title \"Werte\" ",
               "set palette rgb 33,13,10",
               "set view map",
               "splot 'data.temp' with points palette pt 5 ps 0.5"};
  FILE * temp = fopen("data.temp", "w");
  FILE * gnuplotPipe = popen ("gnuplot -persist", "w");
    int i;
    for (i=0; i < dataSize; i++)
    {
      fprintf(temp, "%f %f %f\n", xData[i], yData[i],zData[i]); 
    }
    for (i=0; i < 4; i++)
    {
    fprintf(gnuplotPipe, "%s \n", commandsForGnuplot[i]); 
    }
}

void plotFunction(int d,int* m,int n,double* x)
{ // stellt Gitterfunktion x auf [0,1]^d graphisch dar:
  // Input: m[k] anzahl der gitterpunkte in k-te Richtung
  double* b;
  double* y;
  int i;
  double h;
  y=(double*)malloc(n*sizeof(double)); 
  b=(double*)malloc(n*sizeof(double)); 
  h=1/double(m[0]+1);
   for (i=0;i<m[0];i++)
      {
	b[i]=(i+1)*h;
      }
   if (d<2)
     {
      PlotResults1D(b,x,n);
     }
   else
     {
       if (d<3)
	 {
           y=(double*)malloc(n*sizeof(double)); 
           h=1/double(m[1]+1);
           for (i=0;i<m[1];i++)
           {
   	    y[i*m[0]]=(i+1)*h;
            vdcopy(m[0],&b[i*m[0]],1,b,1);
           }
           for (i=1;i<m[0];i++)
           {
            vdcopy(m[1],&y[i],m[0],y,m[0]);
           }
           PlotResults2D(b,y,x,n);
	 }
     }
}
#endif
